<?php
//PHP script that generate xml file for JavaPowUpload with specified folder structure.
//2008. Element-IT software.
$source_dir = dirname($_SERVER['SCRIPT_FILENAME'])."/UploadedFiles/";
//file names encoding on server side. All file and folder names should encoded into utf-8
$source_encoding = "cp1251";
//If $direct_output set to true, then generated xml will be printed in response
//and you can specify this script as source for Download.DataURL parameter
//Like this:   <param name="Download.DataURL" value="generatexml.php">
//else  generated xml will be saved to $output_file
$direct_output = true;
$output_file = "";
if($direct_output)
	header('Content-Type: text/xml');

function add_dir($parent, $folder_name, $xml_parent, $dom)
{
	GLOBAL $source_dir;
	if($handle = opendir($parent))
	{
		if($parent != $source_dir)
		{
			$folder = $dom->createElement('folder');
			$folder->setAttribute('name',iconv($source_encoding,"UTF-8",$folder_name));
		}
		else
			$folder = $xml_parent;
	    while (false !== ($file = readdir($handle)))
	    {
	        if ($file != "." && $file != "..")
	    	{
	        	if(is_dir($parent.$file))
	            	add_dir($parent.$file."\\", $file, $folder, $dom);
	        }
	    }
	    rewinddir($handle);
		while (false !== ($file = readdir($handle)))
	    {
	        if ($file != "." && $file != "..")
	    	{
	        	if(is_file($parent.$file))
	        	{
	            	$file_node = $dom->createElement('file');
					$file_node->setAttribute('name',iconv($source_encoding,"UTF-8",$file));
					$file_node->setAttribute('length',filesize($parent.$file));
					$url = $dom->createElement('url');
					//REPLACE  $download_url with needed value!
					$relative_parent = str_replace("\\", "/", substr($parent, strlen($source_dir), strlen($parent)-strlen($source_dir)));
					$download_url = iconv($source_encoding,"UTF-8",'FileProcessingScripts/PHP/UploadedFiles/'.$relative_parent.rawurlencode($file));
					$url->appendChild($dom->createTextNode($download_url));
					$file_node->appendChild($url);
                    $folder->appendChild($file_node);
	         	}
	        }
	    }
	    if($parent != $source_dir)
		    $xml_parent->appendChild($folder);
	    closedir($handle);
	}
}

$dom_doc = new DOMDocument('1.0', 'UTF-8');

$rootelement_download= $dom_doc ->createElement('download');

add_dir($source_dir, "", $rootelement_download, $dom_doc );

$dom_doc ->appendChild($rootelement_download);
$dom_doc ->normalize();
if($direct_output)
	print $dom_doc->saveXML();
else
	$dom_doc->save($output_file);

?>
